#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_MouseEventType
#include <snow/platform/native/input/sdl/MouseEventType.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

::snow::platform::native::input::sdl::MouseEventType MouseEventType_obj::down;

::snow::platform::native::input::sdl::MouseEventType MouseEventType_obj::move;

::snow::platform::native::input::sdl::MouseEventType MouseEventType_obj::unknown;

::snow::platform::native::input::sdl::MouseEventType MouseEventType_obj::up;

::snow::platform::native::input::sdl::MouseEventType MouseEventType_obj::wheel;

HX_DEFINE_CREATE_ENUM(MouseEventType_obj)

int MouseEventType_obj::__FindIndex(::String inName)
{
	if (inName==HX_CSTRING("down")) return 2;
	if (inName==HX_CSTRING("move")) return 1;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("up")) return 3;
	if (inName==HX_CSTRING("wheel")) return 4;
	return super::__FindIndex(inName);
}

int MouseEventType_obj::__FindArgCount(::String inName)
{
	if (inName==HX_CSTRING("down")) return 0;
	if (inName==HX_CSTRING("move")) return 0;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("up")) return 0;
	if (inName==HX_CSTRING("wheel")) return 0;
	return super::__FindArgCount(inName);
}

Dynamic MouseEventType_obj::__Field(const ::String &inName,bool inCallProp)
{
	if (inName==HX_CSTRING("down")) return down;
	if (inName==HX_CSTRING("move")) return move;
	if (inName==HX_CSTRING("unknown")) return unknown;
	if (inName==HX_CSTRING("up")) return up;
	if (inName==HX_CSTRING("wheel")) return wheel;
	return super::__Field(inName,inCallProp);
}

static ::String sStaticFields[] = {
	HX_CSTRING("unknown"),
	HX_CSTRING("move"),
	HX_CSTRING("down"),
	HX_CSTRING("up"),
	HX_CSTRING("wheel"),
	::String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(MouseEventType_obj::down,"down");
	HX_MARK_MEMBER_NAME(MouseEventType_obj::move,"move");
	HX_MARK_MEMBER_NAME(MouseEventType_obj::unknown,"unknown");
	HX_MARK_MEMBER_NAME(MouseEventType_obj::up,"up");
	HX_MARK_MEMBER_NAME(MouseEventType_obj::wheel,"wheel");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatic(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::down,"down");
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::move,"move");
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::unknown,"unknown");
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::up,"up");
	HX_VISIT_MEMBER_NAME(MouseEventType_obj::wheel,"wheel");
};
#endif

static ::String sMemberFields[] = { ::String(null()) };
Class MouseEventType_obj::__mClass;

Dynamic __Create_MouseEventType_obj() { return new MouseEventType_obj; }

void MouseEventType_obj::__register()
{

hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.MouseEventType"), hx::TCanCast< MouseEventType_obj >,sStaticFields,sMemberFields,
	&__Create_MouseEventType_obj, &__Create,
	&super::__SGetClass(), &CreateMouseEventType_obj, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatic
#endif
#ifdef HXCPP_SCRIPTABLE
    , 0
#endif
);
}

void MouseEventType_obj::__boot()
{
hx::Static(down) = hx::CreateEnum< MouseEventType_obj >(HX_CSTRING("down"),2);
hx::Static(move) = hx::CreateEnum< MouseEventType_obj >(HX_CSTRING("move"),1);
hx::Static(unknown) = hx::CreateEnum< MouseEventType_obj >(HX_CSTRING("unknown"),0);
hx::Static(up) = hx::CreateEnum< MouseEventType_obj >(HX_CSTRING("up"),3);
hx::Static(wheel) = hx::CreateEnum< MouseEventType_obj >(HX_CSTRING("wheel"),4);
}


} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
